SystemOrganization addCategory: #GODCall!

GODData subclass: #GCConference
	instanceVariableNames: 'name acronym categories url importantDates venue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCConference class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:17'!
name: conferenceName acronym: conferenceAcronym url: conferenceUrl what: conferenceCategories when: conferenceImportantDates where: conferenceVenue
	"constructs a GCConference object with all its fields"
	| conference |

	conference := self new.
	conference 	name: conferenceName;
						acronym: conferenceAcronym;
						url: conferenceUrl;
						categories: conferenceCategories;
						importantDates: conferenceImportantDates;
						venue: conferenceVenue.
	^ conference! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym
	^ acronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym: conferenceAcronym
	acronym := conferenceAcronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories
	^ categories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories: conferenceCategories
	categories := conferenceCategories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates
	 ^ importantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates: conferenceImportantDates
	importantDates := conferenceImportantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name
	^ name! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name: conferenceName
	name := conferenceName! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 16:07'!
url
	^ url! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 16:08'!
url: aUrl

	url:= aUrl! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue
	 ^ venue! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue: conferenceVenue
	venue := conferenceVenue! !

Object subclass: #GCImportantDates
	instanceVariableNames: 'startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCImportantDates class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:24'!
from: aStartDate to: anEndDate deadline: aDeadlineDate
	"constructs a GCImportantDates object"
	|importantDates|
	
	importantDates := self new.
	importantDates 	startDate: aStartDate;
							endDate: anEndDate;
							deadlineDate: aDeadlineDate.

	^ importantDates
! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:21'!
deadlineDate
	^ deadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:22'!
deadlineDate: conferenceDeadlineDate
	deadlineDate := conferenceDeadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate
	^ endDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate: conferenceEndDate
	endDate := conferenceEndDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:18'!
startDate
	^ startDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
startDate: conferenceStartDate
	startDate := conferenceStartDate! !

Object subclass: #GCProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCProcessor methodsFor: 'as yet unclassified' stamp: 'fabcm 9/28/2014 13:43'!
conferenceFrom: page withSource: source
"Take information from page (a html code)) and create a GCConference object"

	^ self notYetImplemented.! !

!GCProcessor methodsFor: 'as yet unclassified' stamp: 'cms 10/1/2014 22:30'!
generateGodConferencesFrom: spreadsheet
	"this method will transform the mergedSpreadsheet into a GCConference collection"

	^ Array new.! !

Object subclass: #GCSearchFilter
	instanceVariableNames: 'searchKey category startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCSearchFilter class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 11:58'!
new
	"creates a new object with all fields nil"
	| aSearchFilter |

	aSearchFilter := super new.
	aSearchFilter searchKey: nil;
						category: nil;
						startDate: nil;
						endDate: nil;
						deadlineDate: nil.

	^ aSearchFilter! !

!GCSearchFilter class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 12:02'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 12:05'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate deadline: aDeadlineDate  
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate;
						deadlineDate: aDeadlineDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
category

	^ category! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
category: aCategory
"set category of the conference being searched"
	category := aCategory! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
deadlineDate

	^ deadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:31'!
deadlineDate: aDeadlineDate
"set filter for searching conferences with deadline until aDeadlineDate"
	deadlineDate := aDeadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
endDate

	^ endDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
endDate: anEndDate
"set filter for searching conferences with end date until anEndDate"
	endDate := anEndDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
searchKey

	^ searchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:34'!
searchKey: aSearchKey
"set filter for searching conferences that contain the word aSearchKey"
	searchKey := aSearchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
startDate

	^ startDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:35'!
startDate: aStartDate
"set filter for searching conferences with start date after  aStartDate"
	startDate := aStartDate! !

Object subclass: #GCSourceEnum
	instanceVariableNames: ''
	classVariableNames: 'ConfSearch WikiCFP'
	poolDictionaries: ''
	category: 'GODCall'!

!GCSourceEnum class methodsFor: 'accessing' stamp: 'cms 10/2/2014 22:42'!
confSearch
	self create.
	 ^ ConfSearch.! !

!GCSourceEnum class methodsFor: 'enum creation' stamp: 'cms 10/2/2014 22:42'!
create
	"create class constants if they were not created yet"
	ConfSearch = nil ifTrue: [
		ConfSearch := self basicNew
	].
	WikiCFP = nil ifTrue: [
		WikiCFP  := self basicNew
	].
	
	! !

!GCSourceEnum class methodsFor: 'accessing' stamp: 'cms 10/2/2014 22:44'!
getSources
	"comment stating purpose of message"
	|collection|
	collection := Bag new.
	collection add: self confSearch;
 			    add: self wikiCfp.
	^ collection.
	! !

!GCSourceEnum class methodsFor: 'instance creation' stamp: 'cms 10/2/2014 22:33'!
new
	self error: 'new instances cannot be created'! !

!GCSourceEnum class methodsFor: 'accessing' stamp: 'cms 10/2/2014 22:43'!
wikiCfp
	self create.
	^ WikiCFP.! !

Object subclass: #GCVenue
	instanceVariableNames: 'place city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCVenue class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:29'!
place: aPlace city: aCity country: aCountry 
	"constucts a GCVenue object"
	| venue |

	venue:= self new.
	venue	place: aPlace;
				city: aCity;
				country: aCountry.

	^ venue! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city
	^ city! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city: conferenceCity
	city := conferenceCity! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country
	^ country! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country: conferenceCountry
	country := conferenceCountry! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
place
	^ place! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:26'!
place: conferencePlace
	place := conferencePlace! !

Object subclass: #GODCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GODCall methodsFor: 'initialization' stamp: 'cms 9/28/2014 14:09'!
crawlConferences
	" search for conferences in web, merge information with quallis, and save in database"
	| sourcesCollection urlCollection page spreadsheetCollection spreadsheet mergedSpreadsheet godConference godConferenceCollection|

	sourcesCollection := self getSources.
     
     	sourcesCollection do: [ :source |
   		urlCollection := self getUrlsFrom: source.
	      urlCollection do: [ :url |
			"page := GODWebPageFetcher getUrl: url.
			godConference := GCProcessor conferenceFrom: page withSource: source.
			godConferenceCollection add: godConference"
		]
		"spreadsheet := GODOutputSpreadsheet generateSpreadsheetFrom: godConferenceCollection.
		spreadsheetCollection add: spreadsheet.."
     	].

	spreadsheet :=  self getQuallisFileAsSpreadsheet.
	"mergedSpreadsheet = GODSpreadsheet  mergeSpreadsheets: spreadsheetCollection.
      
	godConferenceCollection = GCProcessor generateGodConferencesFrom: mergedSpreadsheet.
	GODDBInput save: godConferenceCollection."
 
   ^ True.     
	! !

!GODCall methodsFor: 'initialization' stamp: 'fabcm 9/28/2014 13:50'!
getQuallisFileAsSpreadsheet
	"We wait a method from the spreadsheet group to get this input"

	 ^ self notYetImplemented.! !

!GODCall methodsFor: 'initialization' stamp: 'cms 10/2/2014 22:50'!
getSources
	"This method returns the list of sources that we use."

	  ^ GCSourceEnum getSources.! !

!GODCall methodsFor: 'initialization' stamp: 'fabcm 9/28/2014 13:13'!
getUrlsFrom: source
	"for each source there will be a text file source.txt with a list of urls. We wait a method from TextIO to get this input"

	"hardcoded"
	^ #('http://www.wikicfp.com/cfp/servlet/event.showcfp?eventid=37341&copyownerid=51382' 'http://www.wikicfp.com/cfp/servlet/event.showcfp?eventid=36361&copyownerid=225')

! !

!GODCall methodsFor: 'interface' stamp: 'fabcm 9/28/2014 13:17'!
godCallIndexPage
	"generates the index page of GODs Call app"
	| resultPage |

	"resultPage := GODWebGenerator generateGodCallIndexPage" 
	^ resultPage ! !

!GODCall methodsFor: 'interface' stamp: 'cms 10/1/2014 22:30'!
submitForm: searchFilter
	"executes a user's query defined in the searchFilter and returns web page"

	|godConferenceCollection godSpreadsheet resultPage|
      "We still don't have theses classes so we left the flow commented "

	"godConferenceCollection :=  GODDBInput getConferences.

      godConferenceCollection := GODConferenceFilter filter: godConferenceCollection with: searchFilter.

      godSpreadsheet := GODSpreadsheetOutput generateSpreadsheetFrom: godConferenceCollection.
     
	resultPage := GODWebGenerator generateSpreadsheetPageFrom: godSpreadsheet."
	resultPage := GODData new.
     ^ resultPage. ! !
